"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = prompting;

var _yoBasePrompts = _interopRequireDefault(require("yo-base-prompts"));

var _path = _interopRequireDefault(require("path"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function prompting(_x) {
  return _prompting.apply(this, arguments);
}

function _prompting() {
  _prompting = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(yo) {
    var _ref, name, destination, description, version, license, authorName, authorEmail, githubUsername, authorUrl, homepage, repository, features, _ref2, feature, _ref3, installation, demo, dependencies, _ref4, dependencyName, _ref5, dependencyUrl;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return new _yoBasePrompts.default(yo).prompt({
              name: true,
              destination: true,
              description: true,
              version: true,
              license: true,
              authorName: true,
              authorEmail: true,
              githubUsername: true,
              authorUrl: true,
              homepage: true,
              repository: true
            });

          case 2:
            _ref = _context.sent;
            name = _ref.name;
            destination = _ref.destination;
            description = _ref.description;
            version = _ref.version;
            license = _ref.license;
            authorName = _ref.authorName;
            authorEmail = _ref.authorEmail;
            githubUsername = _ref.githubUsername;
            authorUrl = _ref.authorUrl;
            homepage = _ref.homepage;
            repository = _ref.repository;
            features = [];

          case 15:
            _context.next = 17;
            return yo.prompt([{
              type: 'input',
              name: 'feature',
              message: 'Feature:'
            }]);

          case 17:
            _ref2 = _context.sent;
            feature = _ref2.feature;

            if (!(feature === '')) {
              _context.next = 21;
              break;
            }

            return _context.abrupt("break", 24);

          case 21:
            features.push(feature);

          case 22:
            _context.next = 15;
            break;

          case 24:
            _context.next = 26;
            return yo.prompt([{
              type: 'input',
              name: 'installation',
              message: 'Installation command:'
            }, {
              type: 'input',
              name: 'demo',
              message: 'Demo URL:'
            }]);

          case 26:
            _ref3 = _context.sent;
            installation = _ref3.installation;
            demo = _ref3.demo;
            dependencies = [];

          case 30:
            _context.next = 32;
            return yo.prompt([{
              type: 'input',
              name: 'dependencyName',
              message: 'Dependency:'
            }]);

          case 32:
            _ref4 = _context.sent;
            dependencyName = _ref4.dependencyName;

            if (!(dependencyName === '')) {
              _context.next = 36;
              break;
            }

            return _context.abrupt("break", 43);

          case 36:
            _context.next = 38;
            return yo.prompt([{
              type: 'input',
              name: 'dependencyUrl',
              message: 'Dependency URL:',
              default: 'https://example.com'
            }]);

          case 38:
            _ref5 = _context.sent;
            dependencyUrl = _ref5.dependencyUrl;
            dependencies.push({
              name: dependencyName,
              url: dependencyUrl
            });

          case 41:
            _context.next = 30;
            break;

          case 43:
            yo.answers = {
              authorEmail,
              authorName,
              authorUrl,
              demo,
              dependencies,
              description,
              destination,
              features,
              githubUsername,
              homepage,
              installation,
              license,
              name,
              repository,
              version
            };
            yo.composeWith(require.resolve('generator-editorconf'), {
              name: yo.answers.name,
              destination: yo.answers.destination
            });
            yo.composeWith(require.resolve('generator-license'), {
              email: yo.answers.authorEmail,
              license: yo.answers.license,
              name: yo.answers.authorName,
              output: _path.default.resolve(yo.answers.destination, 'LICENSE'),
              website: yo.answers.authorUrl
            });
            yo.context = _objectSpread({}, yo.context, yo.answers);

          case 47:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _prompting.apply(this, arguments);
}